//User needs to include the RGB master dark frame in the raw image folder first and ensure that it is the first entry
//Program assumes that the raw image files are evenly spaced

dir1 = getDirectory("image")
list = getFileList(dir1);
Array.sort(list);
fileName=getInfo("image.filename")
setBatchMode(true);
close();

CR=getNumber("Correlation Range (frames)", 1);
AR=getNumber("Averaging Radius (frames)", 0);
lastframe=getNumber("No. of Images to be Processed",7200);


dir3_1=File.getParent(dir1) + File.separator+ "0_Dark Frame Substracted"+File.separator;
File.makeDirectory(dir3_1);
list1 = getFileList(dir1);


setBatchMode(true);
for (i=AR+1; i<lastframe; i+=CR)
{
for (k=i-AR; k<=i+AR; k++) 
{
 showProgress(i, lastframe);
 open(dir1+list1[0]);
 open(dir1+list1[k]);
 imageCalculator("Difference create", list1[k],list1[0]);	
saveAs(dir3_1+list1[k]);
run("Close");
run("Close");
run("Close");
}
}

File.delete(dir3_1+list1[0]);

Dialog.create("Finished");
Dialog.addMessage("The dark frame has sucessfully been subtracted from all images and are saved on a new location");
Dialog.show();