//Open root Input Directory
//User should ensure that only the relevant images are in the target folder

lastframe= getNumber("Input last image frame to be processed",7200);

dir1 = getDirectory("Open folder containing original images");
format = getFormat();
	//Output directory
	dir2=File.getParent(dir1)+File.separator+ "8-bit"+File.separator;
	File.makeDirectory(dir2);

	listDone = getFileList(dir2);
	list = getFileList(dir1);
	toDo=lastframe-listDone.length;

	setBatchMode(true);
	for (i=listDone.length; i<lastframe; i++) {
	 showProgress(i, lastframe);
	 open(dir1+list[i]);
		run("8-bit");
		saveAs(format, dir2+list[i]);
		//i=i+9;
		close;
	}

//3_Realignment
	//Output directory
	dir3=File.getParent(dir1)+File.separator+ "1_1_Recursive_repositioning_8-bit"+File.separator;
	File.makeDirectory(dir3);

	//check if directories already are proccesed 
	listDone = getFileList(dir3);
	list = getFileList(dir2);
	toDo=lastframe-listDone.length;

	setBatchMode(true);
	for (i=listDone.length; i<lastframe; i++) {
	 showProgress(i, lastframe);
	 open(dir2+list[1]); //realignment is based on image 1
	 open(dir2+list[i]);
		run("Images to Stack", "name=Stack title=[] use");
		run("StackReg ", "transformation=[Rigid Body]");
		run("Delete Slice");
		saveAs(format, dir3+list[i]);
		close;
	}
Dialog.create("Finished");
Dialog.addMessage("All images have succesfully been repositioned");
Dialog.show();

open(dir3+list[1]);
setBatchMode("show");

function getFormat() {
 formats = newArray("TIFF", "8-bit TIFF", "JPEG", "GIF", "PNG",
 "PGM", "BMP", "FITS", "Text Image", "ZIP", "Raw");
 Dialog.create("Batch Convert");
 Dialog.addChoice("Convert to: ", formats, "TIFF");
 Dialog.show();
 return Dialog.getChoice();
}

function convertTo8Bit() {
 if (bitDepth==24)
 run("8-bit Color", "number=256");
 else
 run("8-bit");
}