dir1 = getDirectory("image")
fileName=getInfo("image.filename")
list = getFileList(dir1);

Dialog.create("Images in folder");
Dialog.addMessage("All images will now be processed and stored in a new folder");
Dialog.show();

close();
dir2 = File.getParent(dir1) + File.separator+"1_0_Brightness_Corrected"+File.separator;
File.makeDirectory(dir2);

bc_min = getNumber("Input Brightness Correction LUT min Value", 0); // 0 is the default here
bc_max = getNumber("Input Brightness Correction LUT max Value", 255); // 255 is the default here

setBatchMode(true);
for (i=0; i<list.length; i++) {
 	showProgress(i+1, list.length);
 	open(dir1+list[i]);

	run("Brightness/Contrast...");
	setMinAndMax(bc_min, bc_max);
	call("ij.ImagePlus.setDefault16bitRange", 8);
	run("Apply LUT");
	run("Close");

 saveAs(dir2+list[i]);
 close();
}

Dialog.create("Finished");
Dialog.addMessage("All images have successfully been adjusted.");
Dialog.show();