//Optical Image Analysis for Localized Corrosion V5
//This program calculates the changes in the image with respect to an initial frame
//Changelog
	//User input added for adjusting lowerTh
	//User input added for adjusting number of frames to be processed
//The image inputs for this program should have been processed using processing programs 0 to 1.3

lowerTh = getNumber("Input lower threshold value (0-255)", 5);
lastframe= getNumber("Input last image frame to be processed",3600);

dir1 = getDirectory("image")
list = getFileList(dir1);
Array.sort(list);
fileName=getInfo("image.filename")
setBatchMode(true);
close();


dir3_1=File.getParent(dir1) + File.separator+ "2_1_Changes_From_Start_Subtract_Dark_median filter"+File.separator;
File.makeDirectory(dir3_1);
list1 = getFileList(dir1);

setBatchMode(true);
for (i=0; i<lastframe; i++) {
 showProgress(i+1, list1.length);
 open(dir1+list1[0]);
 open(dir1+list1[i]);
 imageCalculator("Subtract create", list1[0],list1[i]);	
	//run("Threshold...");
	//setThreshold(lowerTh, 255);
	//setOption("BlackBackground", false);
	//run("Convert to Mask");
	//run("Invert");
run("Median...", "radius=2");
saveAs(dir3_1+list1[i]);
run("Close");
run("Close");
run("Close");
}

upperTh=255;

//Execute the tresholding 
dir2 = File.getParent(dir3_1) + File.separator+"2_2_lth="+lowerTh+"_Mask_Subtract_Dark_median filter"+File.separator;
File.makeDirectory(dir2);
for (i=0; i<lastframe; i++) {
 showProgress(i+1, list.length);
 open(dir3_1+list[i]);
	run("8-bit");
	setThreshold(lowerTh, upperTh);
	setOption("BlackBackground", false);
	run("Convert to Mask");
	run("Invert");
	run("Remove Outliers...", "radius=2 threshold=0 which=Bright");	
	saveAs(dir2+list[i]);
	selectImage(nImages); 
	close();
}


//Remove Background
dir3 = File.getParent(dir3_1) + File.separator+"2_3_NoBackground"+"_subtract_dark_median filter"+lowerTh+File.separator;
File.makeDirectory(dir3);
for (i=0; i<lastframe; i++) {
 showProgress(i+1, list.length);

	//Orinial + Threshold (inverse)
		open(dir1+list[i]);
		id1 = getImageID();
		open(dir2+list[i]);
		id2 = getImageID();
		imageCalculator("Transparent-zero create", id1,id2);
		outName = File.getName(list[i]);
		//setMinAndMax(lowerTh, upperTh);
	 	saveAs(dir3 + "/" + outName);
	 	close();
		close();
		close();
}

Dialog.create("Finished");
Dialog.addMessage("The background has sucessfully been removed from all images and are saved on a new location");
Dialog.show();
